/*
 * ConcreteInterface.h
 *
 *  Created on: Feb 8, 2019
 *      Author: andreas
 */

#include <string>
#include <tuple>
#include <ostream>

#ifndef CONCRETEINTERFACE_H_
#define CONCRETEINTERFACE_H_

struct InfoContainer {
	std::string s = "";
	int i = 0;

	std::string getString() const {
		return s;
	}

	InfoContainer(std::string s = "", int i = 0) : s(s), i(i){}
	virtual ~InfoContainer() = default;
};

inline bool operator==(InfoContainer const& a, InfoContainer const& b){
	return std::tie(a.s, a.i) == std::tie(b.s, b.i);
}

inline std::ostream& operator<<(std::ostream& os, InfoContainer const& b){
	return os << b.s << ", " << b.i;
}

class ConcreteInterface {
public:
	ConcreteInterface() = default;
	virtual ~ConcreteInterface() = default;

	virtual InfoContainer askForInfo(){
		// TODO: Real interface not yet implemented.
		return InfoContainer();
	}

	virtual bool saveInfo(InfoContainer const& i){
		// TODO: Real interface not yet implemented.
		return true;
	}
};

#endif /* CONCRETEINTERFACE_H_ */
